close all;

regression_file = 'C:\Users\jrmat\Desktop\Styring av solenoidventiler DENSO\Valve Control DENSO Folder\IProcess\Matlab\regression_overview.csv';
denso_file = 'C:\Users\jrmat\Desktop\Styring av solenoidventiler DENSO\Valve Control DENSO Folder\IProcess\Matlab\Data\densodataOVectors_validation.csv';

[baseName, folder] = uigetfile('*.csv','*.csv','C:\Users\jrmat\Desktop\Styring av solenoidventiler DENSO\Valve Control DENSO Folder\IProcess');
csv_file = fullfile(folder, baseName);


denso_import = importdata(denso_file);
denso = transpose(denso_import.data(1:17,:));

csv_import = importdata(csv_file);
csv = transpose(csv_import.data(1:17,:));

%%%% Regression to CSV
csv_regress = zeros(1,17);
for i = 1:17
    temp = regression(denso(:,i), csv(:,i),'one');
    csv_regress(i) = temp;
end


a = fopen(regression_file,'a');
fprintf(a, '%s, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f\n', csv_file, csv_regress);


fclose('all');

%%%% Regression figures
labels = { 'X'; 'Y'; 'Z'; 'O1x'; 'O1y'; 'O1z'; 'Ax'; 'Ay'; 'Az'; 'O2x'; 'O2y'; 'O2z'; 'Figure'; 'Preshape'; 'Finger 1'; 'Finger 2'; 'Finger 3'};

new_folder = [folder, '/', baseName(1:end-4)];
mkdir(new_folder);

for i = 1:17
    if (i ~= 13) && (i ~= 14)
        plotregression(denso(:,i),csv(:,i),strtrim(labels(i)))
        print([new_folder, '/fig_', strjoin(labels(i))], '-dpng', '-r500')
    end
end

for i = 1:4
    plotregression(denso(:,3*i-2),csv(:,3*i-2),labels(3*i-2),denso(:,3*i-1),csv(:,3*i-1),labels(3*i-1),denso(:,3*i),csv(:,3*i),labels(3*i))
    print([new_folder, '/fig_3in1_', int2str(i)], '-dpng', '-r500')
end

plotregression(denso(:,1),csv(:,1),'X',denso(:,2),csv(:,2),'Y',denso(:,3),csv(:,3),'Z',...
               denso(:,4),csv(:,4),'O1x',denso(:,5),csv(:,5),'O1y',denso(:,6),csv(:,6),'O1z',...
               denso(:,15),csv(:,15),'Finger 1',denso(:,16),csv(:,16),'Finger 2',denso(:,17),csv(:,17),'Finger 3')
print([new_folder, '/fig_pos_ori_pres'],'-dpng', '-r500')



