function [mdl] = fitcvrsvm(X,y,k,epsilon,cexp,gexp)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

n = size(X,1);
nd = size(y,2);

% epsilon = 2.0;
for d = 1:nd;
    
    disp('-');
    disp(sprintf('Response variable %u of %u',d,nd));
    disp('---------------------------');
    % cexp = -8:2:10;
    % gexp = -4:2:10;
    
    % k = 10;
    if length(epsilon) == nd
        epsilonused = epsilon(d);
    else
        epsilonused = epsilon(1);
    end
    
    c = cvpartition(n,'KFold',k);
    
    cverror = zeros(length(cexp),length(gexp),k);
    
    for ifold = 1:k
        
        disp(sprintf('Fold %u of %u',ifold,k));
        
        % Train
        Xtr = X(c.training(ifold),:);
        ytr = y(c.training(ifold),:);
        
        % Test
        Xte = X(c.test(ifold),:);
        yte = y(c.test(ifold),:);
        
        % Standardize
        % mu = mean(Xtr,1);
        % si = std(Xtr,1);
        % si(si == 0) = 1;
        %
        % for dim = 1:size(X,2)
        %
        %     Xtr(:,dim) = (Xtr(:,dim) - mu(dim))/si(dim);
        %     Xte(:,dim) = (Xte(:,dim) - mu(dim))/si(dim);
        % end
        
        for icexp = 1:length(cexp)
            for igexp = 1:length(gexp)
                
                %
                gamma = 2^gexp(igexp);
                sigma = sqrt(1/2*gamma);
                
                mdld = fitrsvm(Xtr,ytr(:,d),'Standardize','on','KernelFunction','gaussian','KernelScale',sigma,'BoxConstraint',2^cexp(icexp),'Epsilon',epsilonused,'Solver','SMO');
                
                ydfit = predict(mdld,Xte);
                ydtest = yte(:,d);
                
                cverror1(icexp,igexp,ifold) = mean(double(abs(ydfit-ydtest) > epsilonused).*abs(ydfit-ydtest));
                cverror2(icexp,igexp,ifold) = mean(abs(ydfit-ydtest));
                cverror3(icexp,igexp,ifold) = mean((ydfit-ydtest).^2);
            end
        end
        
    end
    
    mcverror1 = sqrt(sum(cverror1,3)/k);
    
    mcverror2 = sum(cverror2,3)/k;
    mcverror3 = sum(cverror3,3)/k;
    %
    % figure;imagesc(rmserror);axis equal;axis tight;colorbar;
    %
    % figure;imagesc(mcverror2);axis equal;axis tight;colorbar;
    %
    % figure;imagesc(mcverror3);axis equal;axis tight;colorbar;
    disp(' ');
    toc
    
    cv1besticexp = 1;
    cv1bestigexp = 1;
    bestcv1 = inf;
    for icexp = 1:length(cexp)
        for igexp = 1:length(gexp)
            if mcverror1(icexp,igexp) < bestcv1
                bestcv1 = mcverror1(icexp,igexp);
                cv1besticexp = icexp;
                cv1bestigexp = igexp;
            end
        end
    end
    
    
    gamma = 2^gexp(cv1bestigexp);
    sigma = sqrt(1/2*gamma);
    
    mdls = fitrsvm(X,y(:,d),'Standardize','on','KernelFunction','gaussian','KernelScale',sigma,'BoxConstraint',2^cexp(cv1besticexp),'Epsilon',epsilonused,'Solver','SMO');
    
    mdl(d).svmmodel = mdls;
    
end

