function [ypred] = predictfromrbfsvmparams(X, b, alpha, gamma, mu, sigma, Xsv)
% Created by John Reidar Mathiassen, August 17, 2016.

k = size(Xsv,1);
d = size(Xsv,2);

n = size(X,1);

% Standardize X
for i = 1:n
   X(i,:) = (X(i,:) - mu)./sigma; 
end

% Standardize Xsv
for j = 1:k
   Xsv(j,:) = (Xsv(j,:) - mu)./sigma; 
end

% Predict y
ypred = zeros(n,1);
for i = 1:n
   ypred(i) = b;
   for j = 1:k
      ypred(i) = ypred(i) + alpha(j)*exp(-gamma*norm(X(i,:)-Xsv(j,:))^2); 
   end
end


end