function writersvmmodel(filename,mdl,X)

nr = length(mdl);
RSVMPARAMS = [];
for ir = 1:nr
    [b, alpha, gamma, mu, sigma, Xsv] = extractrbfsvmparams(mdl(ir).svmmodel,X);
    
    % Package rbf SVM parameters into a 2D array for export to LabVIEW

    k = size(Xsv,1);
    d = size(Xsv,2);

    tmp = zeros(k+2,d+1);
    tmp(1,1) = b;
    tmp(2,1) = gamma;
    tmp(1,2:end) = mu;
    tmp(2,2:end) = sigma;
    tmp(3:end,1) = alpha;
    tmp(3:end,2:end) = Xsv;

    RSVMPARAMS = [RSVMPARAMS;d k zeros(1,d-1);tmp];     %#ok<AGROW>
    
end
save(filename,'RSVMPARAMS','-ascii','-tabs');

end