import tensorflow as tf
from iProcessData import IProcessData
import numpy as np

"""
https://www.tensorflow.org/tutorials/mnist/beginners/

"""

data = IProcessData(True)
data.split_train_test(test_percentage=0.2)
data.augment_data(augmentation_count=15, augmentation_std=50)
normalize = True
if(normalize):
    data.output_to_norm()
#data.print_max_min()


x = tf.placeholder(tf.float32, [None, 3])
y_ = tf.placeholder(tf.float32, [None, 3])

W = tf.Variable(tf.zeros([3, 3]), name="Weight")
b = tf.Variable(tf.zeros([3]), name="bias")

y = tf.add(tf.matmul(x, W), b)


loss = tf.nn.l2_loss(tf.sub(y_, y))

train_step = tf.train.AdamOptimizer(0.00001).minimize(loss)

init = tf.global_variables_initializer()

sess = tf.Session()
sess.run(init)

batches = data.get_training_batches(100)
EPOCHS = 5000
for epoch in range(EPOCHS):
    for batch in range(len(batches['x'])):
        _,run_loss = sess.run([train_step, loss], feed_dict={x: batches['x'][batch], y_: batches['y'][batch]})

    if epoch % (EPOCHS/20) == 0:
        print('Epoch\t', epoch)
        print("Loss\t", run_loss)
        # TODO: ADD VALIDATION ACCURACY - SHOULD INCREASE, LOSS SHOULD FALL

        y_pred, val_loss = sess.run([y, loss], feed_dict={x: data.x_test, y_: data.y_test})
        acc = tf.reduce_mean(tf.divide(tf.sub(y_pred, data.y_test), y_pred), 0)
        print("Acc\t", sess.run(acc), sess.run(tf.reduce_mean(acc)))

        print(10*' -')

print(10*'- predict ')
for a in range(10):
    get_example = data.get_single_test(a)

    x_in = get_example['x']
    y_out = get_example['y']
    print("X\t", x_in)
    print("y_\t",y_out)
    y_pred,val_loss = sess.run([y, loss], feed_dict={x: [x_in], y_: [y_out]})
    print("y\t",y_pred[0])
    print("acc\t", sess.run(tf.divide(tf.sub(y_pred, y_out), y_pred))[0])
    print("loss\t",val_loss)
    if(normalize):
        print("X\t",data.data_norm_to_output(y_out))
        print("Y_\t",data.data_norm_to_output(y_pred[0]))

    print(' -'*10)



# accuracy = tf.reduce_mean(tf.cast(correct_prediction, tf.float32))
# print(sess.run(accuracy, feed_dict={x: data.x_test, y_: data.y_test}))
