from scipy import stats

from iProcessData import csv_to_nparray
from datetime import datetime
import numpy as np


CSV_FILE = "data/regression_model.csv"

DENSO = "data/densodataOVectors.csv"
PREDICTION = "tf_predictions/TESTING.csv"

denso_lab, denso_val = csv_to_nparray(DENSO)
pred_lab, pred_val = csv_to_nparray(PREDICTION)

denso_val = denso_val[:,:17]

def write_regression(regression_file, prediction_file, denso_values, prediction_values):

    if(denso_values.shape == prediction_values.shape):
        print(denso_values.shape)
        print(prediction_values.shape)

    print(denso_values.shape)

    time = datetime.now().strftime('_%y%m%d_%H%M')
    data = []
    string = prediction_file + time
    for i in range(17):
        denso_column = denso_values[:, i]
        pred_column = prediction_values[:, i]

        column_regress = (stats.linregress(denso_column, pred_column)[2])

        rounded_column = round(column_regress, 6)
        string += "\t" + str(rounded_column)

        data.append(float(rounded_column))
    with open(regression_file, "a") as f:
        f.write(string + "\n")

    print(data)



write_regression(CSV_FILE, PREDICTION, denso_val, pred_val)
write_regression(CSV_FILE, PREDICTION, pred_val, denso_val)
